from xapi import *
import traceback
class Unimplemented(Rpc_light_failure):
    def __init__(self, arg_0):
        Rpc_light_failure.__init__(self, "Unimplemented", [ arg_0 ])
        if type(arg_0) <> type("") and type(arg_0) <> type(u""):
            raise (TypeError("string", repr(arg_0)))
        self.arg_0 = arg_0
class Datapath_server_dispatcher:
    """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
    def __init__(self, impl):
        """impl is a proxy object whose methods contain the implementation"""
        self._impl = impl
    def attach(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        if not(args.has_key('uri')):
            raise UnmarshalException('argument missing', 'uri', '')
        uri = args["uri"]
        if type(uri) <> type("") and type(uri) <> type(u""):
            raise (TypeError("string", repr(uri)))
        if not(args.has_key('domain')):
            raise UnmarshalException('argument missing', 'domain', '')
        domain = args["domain"]
        if type(domain) <> type("") and type(domain) <> type(u""):
            raise (TypeError("string", repr(domain)))
        results = self._impl.attach(dbg, uri, domain)
        if type(results['domain_uuid']) <> type("") and type(results['domain_uuid']) <> type(u""):
            raise (TypeError("string", repr(results['domain_uuid'])))
        if results['implementation'][0] == 'Blkback':
            if type(results['implementation'][1]) <> type("") and type(results['implementation'][1]) <> type(u""):
                raise (TypeError("string", repr(results['implementation'][1])))
        elif results['implementation'][0] == 'Tapdisk3':
            if type(results['implementation'][1]) <> type("") and type(results['implementation'][1]) <> type(u""):
                raise (TypeError("string", repr(results['implementation'][1])))
        elif results['implementation'][0] == 'Qdisk':
            if type(results['implementation'][1]) <> type("") and type(results['implementation'][1]) <> type(u""):
                raise (TypeError("string", repr(results['implementation'][1])))
        return results
    def activate(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        if not(args.has_key('uri')):
            raise UnmarshalException('argument missing', 'uri', '')
        uri = args["uri"]
        if type(uri) <> type("") and type(uri) <> type(u""):
            raise (TypeError("string", repr(uri)))
        if not(args.has_key('domain')):
            raise UnmarshalException('argument missing', 'domain', '')
        domain = args["domain"]
        if type(domain) <> type("") and type(domain) <> type(u""):
            raise (TypeError("string", repr(domain)))
        results = self._impl.activate(dbg, uri, domain)
        return results
    def deactivate(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        if not(args.has_key('uri')):
            raise UnmarshalException('argument missing', 'uri', '')
        uri = args["uri"]
        if type(uri) <> type("") and type(uri) <> type(u""):
            raise (TypeError("string", repr(uri)))
        if not(args.has_key('domain')):
            raise UnmarshalException('argument missing', 'domain', '')
        domain = args["domain"]
        if type(domain) <> type("") and type(domain) <> type(u""):
            raise (TypeError("string", repr(domain)))
        results = self._impl.deactivate(dbg, uri, domain)
        return results
    def detach(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        if not(args.has_key('uri')):
            raise UnmarshalException('argument missing', 'uri', '')
        uri = args["uri"]
        if type(uri) <> type("") and type(uri) <> type(u""):
            raise (TypeError("string", repr(uri)))
        if not(args.has_key('domain')):
            raise UnmarshalException('argument missing', 'domain', '')
        domain = args["domain"]
        if type(domain) <> type("") and type(domain) <> type(u""):
            raise (TypeError("string", repr(domain)))
        results = self._impl.detach(dbg, uri, domain)
        return results
    def _dispatch(self, method, params):
        """type check inputs, call implementation, type check outputs and return"""
        args = params[0]
        if method == "Datapath.attach":
            return success(self.attach(args))
        elif method == "Datapath.activate":
            return success(self.activate(args))
        elif method == "Datapath.deactivate":
            return success(self.deactivate(args))
        elif method == "Datapath.detach":
            return success(self.detach(args))
class Datapath_skeleton:
    """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
    def __init__(self):
        pass
    def attach(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        raise Unimplemented("Datapath.attach")
    def activate(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        raise Unimplemented("Datapath.activate")
    def deactivate(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        raise Unimplemented("Datapath.deactivate")
    def detach(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        raise Unimplemented("Datapath.detach")
class Datapath_test:
    """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
    def __init__(self):
        pass
    def attach(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        result = {}
        result["backend"] = { "domain_uuid": "string", "implementation": None }
        return result
    def activate(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        result = {}
        return result
    def deactivate(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        result = {}
        return result
    def detach(self, dbg, uri, domain):
        """Xapi will call the functions here on VM start/shutdown/suspend/resume/migrate. Every function is idempotent. Every function takes a domain parameter which allows the implementation to track how many domains are currently using the volume."""
        result = {}
        return result
class d_server_dispatcher:
    """Demux calls to individual interface server_dispatchers"""
    def __init__(self, Datapath = None):
        self.Datapath = Datapath
    def _dispatch(self, method, params):
        try:
            log("method = %s params = %s" % (method, repr(params)))
            if method.startswith("Datapath") and self.Datapath:
                return self.Datapath._dispatch(method, params)
            raise UnknownMethod(method)
        except Exception, e:
            log("caught %s" % e)
            traceback.print_exc()
            try:
                # A declared (expected) failure will have a .failure() method
                log("returning %s" % (repr(e.failure())))
                return e.failure()
            except:
                # An undeclared (unexpected) failure is wrapped as InternalError
                return (InternalError(str(e)).failure())
class d_server_test(d_server_dispatcher):
    """Create a server which will respond to all calls, returning arbitrary values. This is intended as a marshal/unmarshal test."""
    def __init__(self):
        d_server_dispatcher.__init__(self, Datapath_server_dispatcher(Datapath_test()))