from xapi import *
import traceback
class Unimplemented(Rpc_light_failure):
    def __init__(self, arg_0):
        Rpc_light_failure.__init__(self, "Unimplemented", [ arg_0 ])
        if type(arg_0) <> type("") and type(arg_0) <> type(u""):
            raise (TypeError("string", repr(arg_0)))
        self.arg_0 = arg_0
class Plugin_server_dispatcher:
    """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
    def __init__(self, impl):
        """impl is a proxy object whose methods contain the implementation"""
        self._impl = impl
    def query(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        results = self._impl.query(dbg)
        if type(results['plugin']) <> type("") and type(results['plugin']) <> type(u""):
            raise (TypeError("string", repr(results['plugin'])))
        if type(results['name']) <> type("") and type(results['name']) <> type(u""):
            raise (TypeError("string", repr(results['name'])))
        if type(results['description']) <> type("") and type(results['description']) <> type(u""):
            raise (TypeError("string", repr(results['description'])))
        if type(results['vendor']) <> type("") and type(results['vendor']) <> type(u""):
            raise (TypeError("string", repr(results['vendor'])))
        if type(results['copyright']) <> type("") and type(results['copyright']) <> type(u""):
            raise (TypeError("string", repr(results['copyright'])))
        if type(results['version']) <> type("") and type(results['version']) <> type(u""):
            raise (TypeError("string", repr(results['version'])))
        if type(results['required_api_version']) <> type("") and type(results['required_api_version']) <> type(u""):
            raise (TypeError("string", repr(results['required_api_version'])))
        if type(results['features']) <> type([]):
            raise (TypeError("string list", repr(results['features'])))
        for x in results['features']:
            if type(x) <> type("") and type(x) <> type(u""):
                raise (TypeError("string", repr(x)))
        if type(results['configuration']) <> type({}):
            raise (TypeError("(string * string) list", repr(results['configuration'])))
        for x in results['configuration'].keys():
            if type(x) <> type("") and type(x) <> type(u""):
                raise (TypeError("string", repr(x)))
        for x in results['configuration'].values():
            if type(x) <> type("") and type(x) <> type(u""):
                raise (TypeError("string", repr(x)))
        return results
    def ls(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        results = self._impl.ls(dbg)
        if type(results) <> type([]):
            raise (TypeError("string list", repr(results)))
        for x in results:
            if type(x) <> type("") and type(x) <> type(u""):
                raise (TypeError("string", repr(x)))
        return results
    def diagnostics(self, args):
        """type-check inputs, call implementation, type-check outputs and return"""
        if type(args) <> type({}):
            raise (UnmarshalException('arguments', 'dict', repr(args)))
        if not(args.has_key('dbg')):
            raise UnmarshalException('argument missing', 'dbg', '')
        dbg = args["dbg"]
        if type(dbg) <> type("") and type(dbg) <> type(u""):
            raise (TypeError("string", repr(dbg)))
        results = self._impl.diagnostics(dbg)
        if type(results) <> type("") and type(results) <> type(u""):
            raise (TypeError("string", repr(results)))
        return results
    def _dispatch(self, method, params):
        """type check inputs, call implementation, type check outputs and return"""
        args = params[0]
        if method == "Plugin.query":
            return success(self.query(args))
        elif method == "Plugin.ls":
            return success(self.ls(args))
        elif method == "Plugin.diagnostics":
            return success(self.diagnostics(args))
class Plugin_skeleton:
    """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
    def __init__(self):
        pass
    def query(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        raise Unimplemented("Plugin.query")
    def ls(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        raise Unimplemented("Plugin.ls")
    def diagnostics(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        raise Unimplemented("Plugin.diagnostics")
class Plugin_test:
    """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
    def __init__(self):
        pass
    def query(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        result = {}
        result["query_result"] = { "plugin": "string", "name": "string", "description": "string", "vendor": "string", "copyright": "string", "version": "string", "required_api_version": "string", "features": [ "string", "string" ], "configuration": { "string": "string" } }
        return result
    def ls(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        result = {}
        result["srs"] = [ "string", "string" ]
        return result
    def diagnostics(self, dbg):
        """Discover properties of this implementation. Every implementation  must support the query interface or it will not be recognised as  a storage plugin by xapi."""
        result = {}
        result["diagnostics"] = "string"
        return result
class p_server_dispatcher:
    """Demux calls to individual interface server_dispatchers"""
    def __init__(self, Plugin = None):
        self.Plugin = Plugin
    def _dispatch(self, method, params):
        try:
            log("method = %s params = %s" % (method, repr(params)))
            if method.startswith("Plugin") and self.Plugin:
                return self.Plugin._dispatch(method, params)
            raise UnknownMethod(method)
        except Exception, e:
            log("caught %s" % e)
            traceback.print_exc()
            try:
                # A declared (expected) failure will have a .failure() method
                log("returning %s" % (repr(e.failure())))
                return e.failure()
            except:
                # An undeclared (unexpected) failure is wrapped as InternalError
                return (InternalError(str(e)).failure())
class p_server_test(p_server_dispatcher):
    """Create a server which will respond to all calls, returning arbitrary values. This is intended as a marshal/unmarshal test."""
    def __init__(self):
        p_server_dispatcher.__init__(self, Plugin_server_dispatcher(Plugin_test()))